Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2008)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2011)
@@ -1,4 +1,2 @@
- MODULE urban_surface_mod
-
 !> @file urban_surface_mod.f90
 !--------------------------------------------------------------------------------!
@@ -23,5 +21,11 @@
 ! Current revisions:
 ! ------------------
-! 
+! Major reformatting according to PALM coding standard (comments, blanks,
+! alphabetical ordering, etc.),
+! removed debug_prints, 
+! removed auxiliary SUBROUTINE get_usm_info, instead, USM flag urban_surface is
+! defined in MODULE control_parameters (modules.f90) to avoid circular 
+! dependencies,
+! renamed canopy_heat_flux to pc_heating_rate, as meaning of quantity changed.
 ! 
 ! Former revisions:
@@ -67,7 +71,35 @@
 !>
 !------------------------------------------------------------------------------!
+ MODULE urban_surface_mod
+
+    USE arrays_3d,                                                             &
+        ONLY:  zu, pt, pt_1, pt_2, p, ol, shf, ts, us, u, v, w, hyp, tend
+
+    USE cloud_parameters,                                                      &
+        ONLY:  cp, r_d
 
     USE constants,                                                             &
-        only: pi
+        ONLY:  pi
+    
+    USE control_parameters,                                                    &
+        ONLY:  dz, topography, dt_3d, intermediate_timestep_count,             &
+               initializing_actions, intermediate_timestep_count_max,          &
+               simulated_time, end_time, timestep_scheme, tsc,                 &
+               coupling_char, io_blocks, io_group, message_string,             &
+               time_since_reference_point, surface_pressure,                   &
+               g, pt_surface, large_scale_forcing, lsf_surf,                   &
+               time_do3d, dt_do3d, average_count_3d, urban_surface
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point, log_point_s
+     
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy, ddx, ddy, ddx2, ddy2
+    
+    USE indices,                                                               &
+        ONLY:  nx, ny, nnx, nny, nnz, nxl, nxlg, nxr, nxrg, nyn, nyng, nys,    &
+               nysg, nzb_s_inner, nzb_s_outer, nzb, nzt, nbgp
+
+    USE, INTRINSIC :: iso_c_binding 
 
     USE kinds
@@ -75,25 +107,7 @@
     USE pegrid
     
-    USE indices,                                                               &
-         only: nx, ny, nnx, nny, nnz, nxl, nxlg, nxr, nxrg, nyn, nyng, nys,    &
-               nysg, nzb_s_inner, nzb_s_outer, nzb, nzt, nbgp
-    
-    USE control_parameters,                                                    &
-         ONLY:  dz, topography, dt_3d, intermediate_timestep_count,            &
-                initializing_actions, intermediate_timestep_count_max,         &
-                simulated_time, end_time, timestep_scheme, tsc,                &
-                coupling_char, io_blocks, io_group, message_string,            &
-                time_since_reference_point, surface_pressure,                  &
-                g, pt_surface, large_scale_forcing, lsf_surf,                  &
-                time_do3d, dt_do3d, average_count_3d
-     
-    USE grid_variables,                                                        &
-        ONLY: dx, dy, ddx, ddy, ddx2, ddy2
-              
-    USE arrays_3d,                                                             &
-        ONLY:  zu, pt, pt_1, pt_2, p, ol, shf, ts, us, u, v, w, hyp, tend
-
-    USE cloud_parameters,                                                      &
-        ONLY:  cp, r_d
+    USE plant_canopy_model_mod,                                                &
+        ONLY:  plant_canopy, pch_index,                                        &
+               pc_heating_rate, lad_s
     
     USE radiation_model_mod,                                                   &
@@ -102,17 +116,7 @@
                sigma_sb, sun_direction, sun_dir_lat, sun_dir_lon,              &
                force_radiation_call
-    
-    USE plant_canopy_model_mod,                                                &
-        ONLY:  plant_canopy, pch_index,                                        &
-               canopy_heat_flux, lad_s
 
     USE statistics,                                                            &
-         ONLY:  hom, statistic_regions
-
-    USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point, log_point_s
-
-    ! USE ieee_arithmetic
-    USE, INTRINSIC :: iso_c_binding 
+        ONLY:  hom, statistic_regions
 
                
@@ -120,12 +124,11 @@
     IMPLICIT NONE
 
-    !-- configuration parameters (they can be setup in PALM config)
-    LOGICAL                                        ::  urban_surface = .FALSE.            !< switch for use of urban surface model
+!-- configuration parameters (they can be setup in PALM config)
     LOGICAL                                        ::  split_diffusion_radiation = .TRUE. !< split direct and diffusion dw radiation
                                                                                           !< (.F. in case the radiation model already does it)    
     LOGICAL                                        ::  usm_energy_balance_land = .TRUE.   !< flag parameter indicating wheather the energy balance is calculated for land and roofs
     LOGICAL                                        ::  usm_energy_balance_wall = .TRUE.   !< flag parameter indicating wheather the energy balance is calculated for land and roofs
+    LOGICAL                                        ::  usm_material_model = .TRUE.        !< flag parameter indicating wheather the  model of heat in materials is used
     LOGICAL                                        ::  usm_anthropogenic_heat = .FALSE.   !< flag parameter indicating wheather the anthropogenic heat sources (e.g.transportation) are used
-    LOGICAL                                        ::  usm_material_model = .TRUE.        !< flag parameter indicating wheather the wsm is used
     LOGICAL                                        ::  force_radiation_call_l = .FALSE.   !< flag parameter for unscheduled radiation model calls
     LOGICAL                                        ::  mrt_factors = .FALSE.              !< whether to generate MRT factor files during init
@@ -133,5 +136,4 @@
     LOGICAL                                        ::  read_svf_on_init = .FALSE.
     LOGICAL                                        ::  usm_lad_rma = .TRUE.               !< use MPI RMA to access LAD for raytracing (instead of global array)
-    LOGICAL                                        ::  debug_prints = .FALSE.             !< print debug messages into process debug files
     
     INTEGER(iwp)                                   ::  nrefsteps = 0                      !< number of reflection steps to perform
@@ -147,5 +149,5 @@
                                                                                           !< of r_a for horizontal surfaces -> TODO
     
-    !-- parameters of urban surface model
+!-- parameters of urban surface model
     INTEGER(iwp), PARAMETER                        ::  usm_version_len = 10               !< length of identification string of usm version
     CHARACTER(usm_version_len), PARAMETER          ::  usm_version = 'USM v. 1.0'         !< identification of version of binary svf and restart files
@@ -180,9 +182,5 @@
                                                                                           !< parameter but set in the code
 
-    !-- indices and sizes of urban surface model
-!ketelsen:    INTEGER(iwp), DIMENSION(:,:,:,:), ALLOCATABLE  ::  gridsurf         !< array of indices of the surfaces in local block in global vector of indices
-                                                                        !< of surfaces for grid coordinates (d,z,y,x)
-                                                                        !< d = 0 groud/roof, 1 south wall, 2 north wall, 3 west wall, 4 east wall
-                                                                        !< 5 free north border, 6 free south b., 7 free east b., 8 free west b.
+!-- indices and sizes of urban surface model
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  surfl            !< coordinates of i-th local surface in local grid - surfl[:,k] = [d, z, y, x]
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  surf             !< coordinates of i-th surface in grid - surf[:,k] = [d, z, y, x]
@@ -211,5 +209,5 @@
 
 
-    !-- type for calculation of svf
+!-- type for calculation of svf
     TYPE t_svf
         INTEGER(iwp)                               :: isurflt           !< 
@@ -219,5 +217,5 @@
     END TYPE
 
-    !-- type for calculation of csf
+!-- type for calculation of csf
     TYPE t_csf
         INTEGER(iwp)                               :: ip                !< 
@@ -230,5 +228,5 @@
     END TYPE
 
-    !-- arrays for calculation of svf and csf
+!-- arrays for calculation of svf and csf
     TYPE(t_svf), DIMENSION(:), POINTER             ::  asvf             !< pointer to growing svc array
     TYPE(t_csf), DIMENSION(:), POINTER             ::  acsf             !< pointer to growing csf array
@@ -240,5 +238,5 @@
     INTEGER(iwp), PARAMETER                        ::  gasize = 10000   !< initial size of growing arrays
 
-    !-- arrays storing the values of USM
+!-- arrays storing the values of USM
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  svfsurf          !< svfsurf[:,isvf] = index of source and target surface for svf[isvf]
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  svf              !< array of shape view factors+direct irradiation factors
@@ -264,5 +262,5 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  rad_net_l        !< local copy of rad_net (net radiation at surface)
 
-    !-- arrays for time averages
+!-- arrays for time averages
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  rad_net_av       !< average of rad_net_l
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinsw_av      !< average of sw radiation falling to local surface including radiation from reflections
@@ -277,5 +275,5 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfhf_av        !< average of total radiation flux incoming to minus outgoing from local surface    
     
-    !-- block variables needed for calculation of the plant canopy model inside the urban surface model
+!-- block variables needed for calculation of the plant canopy model inside the urban surface model
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  pcbl             !< z,y,x coordinates of i-th local plant canopy box pcbl[:,i] = [z, y, x]
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE    ::  gridpcbl         !< index of local pcb[z,y,x]
@@ -290,19 +288,19 @@
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  nzterr, plantt   !< temporary global arrays for raytracing
     
-    !-- radiation related arrays (it should be better in interface of radiation module of PALM
+!-- radiation related arrays (it should be better in interface of radiation module of PALM
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rad_sw_in_dir    !< direct sw radiation
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rad_sw_in_diff   !< diffusion sw radiation
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rad_lw_in_diff   !< diffusion lw radiation
 
-    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    !-- anthropogenic heat sources
-    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!-- anthropogenic heat sources
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  aheat             !< daily average of anthropogenic heat (W/m2)
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  aheatprof         !< diurnal profile of anthropogenic heat 
 
-    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    !-- wall surface model
-    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    !-- wall surface model constants
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!-- wall surface model
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!-- wall surface model constants
     INTEGER(iwp), PARAMETER                        :: nzb_wall = 0       !< inner side of the wall model (to be switched)
     INTEGER(iwp), PARAMETER                        :: nzt_wall = 3       !< outer side of the wall model (to be switched)
@@ -316,7 +314,7 @@
     REAL(wp)                                       ::   soil_inner_temperature = 283.0_wp    !< temperature of the deep soil (~10 degrees C) (K)
 
-    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    !-- surface and material model variables for walls, ground, roofs
-    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!-- surface and material model variables for walls, ground, roofs
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE        :: surface_types      !< array of types of wall parameters
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: zwn                !< normalized wall layer depths (m)
@@ -339,19 +337,19 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_av          !< average of wall surface temperature (K)
 
-    !-- Temporal tendencies for time stepping            
+!-- Temporal tendencies for time stepping            
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: tt_surface_m       !< surface temperature tendency (K)
 
-    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    !-- Energy balance variables
-    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    !-- parameters of the land, roof and wall surfaces
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!-- Energy balance variables
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!-- parameters of the land, roof and wall surfaces
     LOGICAL,  DIMENSION(:), ALLOCATABLE            :: isroof_surf        !< is the surface the part of a roof
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: albedo_surf        !< albedo of the surface
-    !-- parameters of the wall surfaces
+!-- parameters of the wall surfaces
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: c_surface          !< heat capacity of the wall surface skin ( J mâ2 Kâ1 )
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: emiss_surf         !< emissivity of the wall surface
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: lambda_surf        !< heat conductivity Î»S between air and surface ( W mâ2 Kâ1 )
     
-    !-- parameters of the walls material
+!-- parameters of the walls material
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: thickness_wall     !< thickness of the wall, roof and soil layers
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: rho_c_wall         !< volumetric heat capacity of the material ( J m-3 K-1 ) (= 2.19E6)
@@ -359,6 +357,5 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: roughness_wall     !< roughness relative to concrete
     
-    !
-    !-- output wall heat flux arrays
+!-- output wall heat flux arrays
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: wshf               !< kinematic wall heat flux of sensible heat (needed for diffusion_s!<)
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: wshf_eb            !< wall heat flux of sensible heat in wall normal direction
@@ -376,9 +373,9 @@
 #endif
 
-    !-- Wall temporal tendencies for time stepping
+!-- Wall temporal tendencies for time stepping
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: tt_wall_m          !< t_wall prognostic array 
 
-    !-- Surface and material parameters classes (surface_type)
-    !-- albedo, emissivity, lambda_surf, roughness, thickness, volumetric heat capacity, thermal conductivity
+!-- Surface and material parameters classes (surface_type)
+!-- albedo, emissivity, lambda_surf, roughness, thickness, volumetric heat capacity, thermal conductivity
     INTEGER(iwp)                                   :: n_surface_types      !< number of the wall type categories
     INTEGER(iwp), PARAMETER                        :: n_surface_params = 8 !< number of parameters for each type of the wall
@@ -397,20 +394,48 @@
     CHARACTER(len=*), PARAMETER                    :: svf_file_name='usm_svf'
     
-    !-- interfaces of subroutines accessed from outside of this module
+!-- interfaces of subroutines accessed from outside of this module
+    INTERFACE usm_check_data_output
+       MODULE PROCEDURE usm_check_data_output
+    END INTERFACE usm_check_data_output
+    
+    INTERFACE usm_check_parameters
+       MODULE PROCEDURE usm_check_parameters
+    END INTERFACE usm_check_parameters
+    
+    INTERFACE usm_data_output_3d
+       MODULE PROCEDURE usm_data_output_3d
+    END INTERFACE usm_data_output_3d
+    
+    INTERFACE usm_define_netcdf_grid
+       MODULE PROCEDURE usm_define_netcdf_grid
+    END INTERFACE usm_define_netcdf_grid
+
     INTERFACE usm_init_urban_surface
        MODULE PROCEDURE usm_init_urban_surface
     END INTERFACE usm_init_urban_surface
 
+    INTERFACE usm_material_heat_model
+       MODULE PROCEDURE usm_material_heat_model
+    END INTERFACE usm_material_heat_model
+    
+    INTERFACE usm_parin
+       MODULE PROCEDURE usm_parin
+    END INTERFACE usm_parin
+
     INTERFACE usm_radiation
        MODULE PROCEDURE usm_radiation
     END INTERFACE usm_radiation
+    
+    INTERFACE usm_read_restart_data 
+       MODULE PROCEDURE usm_read_restart_data
+    END INTERFACE usm_read_restart_data
 
     INTERFACE usm_surface_energy_balance
        MODULE PROCEDURE usm_surface_energy_balance
     END INTERFACE usm_surface_energy_balance
-
-    INTERFACE usm_material_heat_model
-       MODULE PROCEDURE usm_material_heat_model
-    END INTERFACE usm_material_heat_model
+    
+    INTERFACE usm_swap_timelevel
+       MODULE PROCEDURE usm_swap_timelevel
+    END INTERFACE usm_swap_timelevel
     
     INTERFACE usm_wall_heat_flux
@@ -419,32 +444,4 @@
     END INTERFACE usm_wall_heat_flux
     
-    INTERFACE usm_swap_timelevel
-       MODULE PROCEDURE usm_swap_timelevel
-    END INTERFACE usm_swap_timelevel
-    
-    INTERFACE usm_check_data_output
-       MODULE PROCEDURE usm_check_data_output
-    END INTERFACE usm_check_data_output
-    
-    INTERFACE usm_check_parameters
-       MODULE PROCEDURE usm_check_parameters
-    END INTERFACE usm_check_parameters
-    
-    INTERFACE usm_data_output_3d
-       MODULE PROCEDURE usm_data_output_3d
-    END INTERFACE usm_data_output_3d
-    
-    INTERFACE usm_define_netcdf_grid
-       MODULE PROCEDURE usm_define_netcdf_grid
-    END INTERFACE usm_define_netcdf_grid
-    
-    INTERFACE usm_parin
-       MODULE PROCEDURE usm_parin
-    END INTERFACE usm_parin
-    
-    INTERFACE usm_read_restart_data 
-       MODULE PROCEDURE usm_read_restart_data
-    END INTERFACE usm_read_restart_data
-    
     INTERFACE usm_write_restart_data
        MODULE PROCEDURE usm_write_restart_data
@@ -454,7 +451,7 @@
 
     PRIVATE
-    !
-    !-- Public parameters, constants and initial values
-    PUBLIC urban_surface, split_diffusion_radiation,                           &
+    
+!-- Public parameters, constants and initial values
+    PUBLIC split_diffusion_radiation,                                          &
            usm_anthropogenic_heat, usm_material_model, mrt_factors,            &
            usm_check_parameters,                                               &
@@ -466,5 +463,5 @@
            usm_data_output_3d, usm_define_netcdf_grid, usm_parin,              &
            usm_write_restart_data,                                             &
-           nzub, nzut, ra_horiz_coef, usm_lad_rma, debug_prints,               &
+           nzub, nzut, ra_horiz_coef, usm_lad_rma,                             &
            land_category, pedestrant_category, wall_category, roof_category,   &
            write_svf_on_init, read_svf_on_init
@@ -473,133 +470,4 @@
  CONTAINS
 
-
- 
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Initialization of the urban surface model
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_init_urban_surface
-    
-        IMPLICIT NONE
-
-        INTEGER(iwp) ::  i, j, k, l            ! running indices
-        REAL(wp)     ::  c, d, tin, exn
-        
-        CALL cpu_log( log_point_s(78), 'usm_init', 'start' )
-        !-- surface forcing have to be disabled for LSF 
-        !-- in case of enabled urban surface module
-        IF ( large_scale_forcing ) THEN
-            lsf_surf = .FALSE.
-        ENDIF
-       
-        !-- init anthropogenic sources of heat
-        CALL usm_allocate_urban_surface()
-       
-        !-- read the surface_types array somewhere
-        CALL usm_read_urban_surface_types()
-        
-        !-- init material heat model
-        CALL usm_init_material_model()
-        
-        IF ( usm_anthropogenic_heat ) THEN
-            !-- init anthropogenic sources of heat (from transportation for now)
-            CALL usm_read_anthropogenic_heat()
-        ENDIF
-        
-        IF ( read_svf_on_init ) THEN
-            !-- read svf and svfsurf data from file
-            WRITE(6,*) myid, 'Before read svf from file'
-            FLUSH(6)
-            CALL usm_read_svf_from_file()
-            WRITE(6,*) myid, 'After read svf from file'
-            FLUSH(6)
-        ELSE
-            !-- calculate SFV and CSF
-            WRITE(6,*) myid, 'Before calc svf'
-            FLUSH(6)
-            CALL cpu_log( log_point_s(79), 'usm_calc_svf', 'start' )     
-            CALL usm_calc_svf()
-            CALL cpu_log( log_point_s(79), 'usm_calc_svf', 'stop' )
-            WRITE(6,*) myid, 'After calc svf'
-            FLUSH(6)
-        ENDIF
-
-        IF ( write_svf_on_init ) THEN
-            !-- write svf and svfsurf data to file
-            WRITE(6,*) myid, 'Before write svf to file'
-            FLUSH(6)
-            CALL usm_write_svf_to_file()
-            WRITE(6,*) myid, 'After write svf to file'
-            FLUSH(6)
-        ENDIF
-        
-        IF ( plant_canopy ) THEN
-            !-- gridpcbl was only necessary for initialization
-            DEALLOCATE( gridpcbl )
-            IF ( .NOT. ALLOCATED(canopy_heat_flux) ) THEN
-                !-- then canopy_heat_flux is allocated in init_plant_canopy
-                !-- in case of cthf /= 0 => we need to allocate it for our use here
-                ALLOCATE( canopy_heat_flux(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-            ENDIF
-        ENDIF
-
-        !-- Intitialization of the surface and wall/ground/roof temperature
-
-        !-- Initialization for restart runs
-        IF (  TRIM( initializing_actions ) == 'read_restart_data' )  THEN
-
-            !-- restore data from restart file
-            CALL usm_read_restart_data()
-        ELSE
-       
-            !-- Calculate initial surface temperature
-            exn = ( surface_pressure / 1000.0_wp )**0.286_wp
-
-            DO l = startenergy, endenergy
-                k = surfl(iz,l)
-                j = surfl(iy,l)
-                i = surfl(ix,l)
-
-                !--  Initial surface temperature set from pt of adjacent gridbox
-                t_surf(l) = pt(k,j,i) * exn
-            ENDDO
-      
-            !-- initial values for t_wall
-            !-- outer value is set to surface temperature
-            !-- inner value is set to wall_inner_temperature
-            !-- and profile is logaritmic (linear in nz)
-            DO l = startenergy, endenergy
-                IF ( isroof_surf(l) ) THEN
-                    tin = roof_inner_temperature
-                ELSE IF ( surf(id,l)==iroof ) THEN
-                    tin = soil_inner_temperature
-                ELSE
-                    tin = wall_inner_temperature
-                ENDIF
-                DO k = nzb_wall, nzt_wall+1
-                    c = REAL(k-nzb_wall,wp)/REAL(nzt_wall+1-nzb_wall,wp)
-                    t_wall(k,:) = (1.0_wp-c)*t_surf(:) + c*tin
-                ENDDO
-            ENDDO
-        ENDIF
-        
-        !
-        !--    Possibly DO user-defined actions (e.g. define heterogeneous wall surface)
-        CALL user_init_urban_surface
-
-        !-- initialize prognostic values for the first timestep
-        t_surf_p = t_surf
-        t_wall_p = t_wall
-        
-        !-- Adjust radiative fluxes for urban surface at model start
-        CALL usm_radiation
-        
-        CALL cpu_log( log_point_s(78), 'usm_init', 'stop' )
-        
-        
-    END SUBROUTINE usm_init_urban_surface
-
-    
  
 !------------------------------------------------------------------------------!
@@ -620,20 +488,20 @@
 
         
-        !-- auxiliary vars
+!--     auxiliary vars
         ddxy2 = (/ddy2,ddy2,ddx2,ddx2/)      !< 1/dx^2 or 1/dy^2 (in surface normal direction)
         
         CALL location_message( '', .TRUE. )
         CALL location_message( '    allocation of needed arrays', .TRUE. )
-        !-- find nzub, nzut, nzu
+!--     find nzub, nzut, nzu
         nzubl = minval(nzb_s_inner(nys:nyn,nxl:nxr))
         nzutl = maxval(nzb_s_inner(nys:nyn,nxl:nxr))
         nzubl = max(nzubl,nzb)
         
-        IF (plant_canopy) THEN
-            !-- allocate needed arrays
+        IF ( plant_canopy )  THEN
+!--         allocate needed arrays
             ALLOCATE( pct(nys:nyn,nxl:nxr) )
             ALLOCATE( pch(nys:nyn,nxl:nxr) )
 
-            !-- calculate plant canopy height
+!--         calculate plant canopy height
             npcbl = 0
             pct = 0.0_wp
@@ -642,6 +510,6 @@
                 DO j = nys, nyn
                     DO k = nzt+1, 0, -1
-                        IF ( lad_s(k,j,i) /= 0.0_wp ) THEN
-                            !-- we are at the top of the pcs
+                        IF ( lad_s(k,j,i) /= 0.0_wp )  THEN
+!--                         we are at the top of the pcs
                             pct(j,i) = k + nzb_s_inner(j,i)
                             pch(j,i) = k
@@ -654,16 +522,16 @@
             
             nzutl = max(nzutl, maxval(pct))
-            !-- code of plant canopy model uses parameter pch_index
-            !-- we need to setup it here to right value
-            !-- (pch_index, lad_s and other arrays in PCM are defined flat)
+!--         code of plant canopy model uses parameter pch_index
+!--         we need to setup it here to right value
+!--         (pch_index, lad_s and other arrays in PCM are defined flat)
             pch_index = maxval(pch)
 
             prototype_lad = maxval(lad_s) * .9_wp  !< better be *1.0 if lad is either 0 or maxval(lad) everywhere
             IF ( prototype_lad <= 0._wp ) prototype_lad = .3_wp
-            WRITE(message_string, '(a,f6.3)') 'Precomputing effective box optical ' &
-                // 'depth using prototype leaf area density = ', prototype_lad
-            CALL message('usm_init_urban_surface', 'PA0520', 0, 0, -1, 6, 0)
+            !WRITE(message_string, '(a,f6.3)') 'Precomputing effective box optical ' &
+            !    // 'depth using prototype leaf area density = ', prototype_lad
+            !CALL message('usm_init_urban_surface', 'PA0520', 0, 0, -1, 6, 0)
         ENDIF
-          
+        
         nzutl = min(nzutl+nzut_free, nzt)
                   
@@ -676,19 +544,12 @@
 #endif
 
-        !-- global number of urban layers
+!--     global number of urban layers
         nzu = nzut - nzub + 1
-        IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN        
-            WRITE(9,*) 'nzub= ', nzub, ' nzut= ', nzut, ' nzu= ', nzu
-            FLUSH(9)
-        ENDIF
-        
-        !-- allocate urban surfaces grid
-!ketelsen:        ALLOCATE(gridsurf(0:9,nzub:nzut,nys:nyn,nxl:nxr))
-!ketelsen:        gridsurf = 0
-        
-        !-- calc number of surfaces in local proc
+        
+!--     allocate urban surfaces grid
+!--     calc number of surfaces in local proc
         CALL location_message( '    calculation of indices for surfaces', .TRUE. )
         nsurfl = 0
-        !-- calculate land surface and roof
+!--     calculate land surface and roof
         startland = nsurfl+1
         nsurfl = nsurfl+(nxr-nxl+1)*(nyn-nys+1)
@@ -696,10 +557,10 @@
         nlands = endland-startland+1
 
-        !-- calculation of the walls
+!--     calculation of the walls
         startwall = nsurfl+1
         DO i = nxl, nxr
             DO j = nys, nyn
-                !-- test for walls
-                !-- (we don't use array flags because it isn't calculated in case of masking_method=.T.)
+!--             test for walls
+!--             (we don't use array flags because it isn't calculated in case of masking_method=.T.)
                 DO ids = 1, 4  !-- four wall directions
                     jr = min(max(j-jdir(ids),0),ny)
@@ -712,7 +573,7 @@
         nwalls = endwall-startwall+1
         
-        !-- range of energy balance surfaces
+!--     range of energy balance surfaces
         nenergy = 0
-        IF ( usm_energy_balance_land ) THEN
+        IF ( usm_energy_balance_land )  THEN
             startenergy = startland
             nenergy = nenergy + nlands
@@ -720,5 +581,5 @@
             startenergy = startwall
         ENDIF
-        IF ( usm_energy_balance_wall ) THEN
+        IF ( usm_energy_balance_wall )  THEN
             endenergy = endwall
             nenergy = nenergy + nwalls
@@ -727,8 +588,8 @@
         ENDIF
 
-        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        !-- block of virtual surfaces
-        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        !-- calculate sky surfaces
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!--     block of virtual surfaces
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!--     calculate sky surfaces
         startsky = nsurfl+1
         nsurfl = nsurfl+(nxr-nxl+1)*(nyn-nys+1)
@@ -736,5 +597,5 @@
         nskys = endsky-startsky+1
         
-        !-- border flags
+!--     border flags
 #if defined( __parallel )
         isborder = (/ north_border_pe, south_border_pe, right_border_pe, left_border_pe /)
@@ -742,10 +603,10 @@
         isborder = (/.TRUE.,.TRUE.,.TRUE.,.TRUE./)
 #endif
-        !-- fill array of the limits of the local domain borders
+!--     fill array of the limits of the local domain borders
         ijdb = RESHAPE( (/ nxl,nxr,nyn,nyn,nxl,nxr,nys,nys,nxr,nxr,nys,nyn,nxl,nxl,nys,nyn /), (/4, 4/) )
-        !-- calulation of the free borders of the domain
+!--     calulation of the free borders of the domain
         DO ids = 6,9
-            IF ( isborder(ids) ) THEN
-                !-- free border of the domain in direction ids
+            IF ( isborder(ids) )  THEN
+!--             free border of the domain in direction ids
                 DO i = ijdb(1,ids), ijdb(2,ids)
                     DO j = ijdb(3,ids), ijdb(4,ids)
@@ -757,6 +618,6 @@
         ENDDO
         
-        !-- fill gridpcbl and pcbl
-        IF ( plant_canopy ) THEN
+!--     fill gridpcbl and pcbl
+        IF ( plant_canopy )  THEN
             ALLOCATE( pcbl(iz:ix, 1:npcbl) )
             ALLOCATE( gridpcbl(nzub:nzut,nys:nyn,nxl:nxr) )
